UNIT Control;

INTERFACE

Uses Crt;


Type vector = array[byte] of real;
     registro = record
       coste: real;
       coste_min: real;
       basico: boolean;
     end;
     matriz = array[1..20,1..20] of registro;

Function LeerFichero(var limite_a, limite_b: byte; var oferta, demanda: vector;
                      var tabla: matriz): boolean;
Procedure Visualizar(tabla: matriz; limite_a, limite_b: byte; oferta,demanda : vector);

IMPLEMENTATION
(***************************************************************************)
Function LeerFichero(var limite_a, limite_b: byte; var oferta, demanda: vector;
                      var tabla: matriz): boolean;
var i,j: byte;
    archivo: string[25];
    fichero: TEXT;
    suma_a, suma_b: real;

Begin
  clrscr;
  write('Introduce el nombre del archivo de datos: ');
  readln(archivo);
  assign(fichero, archivo);
  {$I-}
  reset(fichero);
  {$I+}
  if ioresult <> 0 then
    begin
      clrscr;
      write('ERROR, el fichero ',archivo,' no ha podido abrirse correctamente.');
      readkey;
      LeerFichero:= false;
      exit;
    end;
  {lectura de los datos}
  readln(fichero, limite_a);
  readln(fichero, limite_b);

  for i:= 1 to limite_a do      {se leen los datos de la oferta}
    read(fichero, oferta[i]);
  for i:= 1 to limite_b do      {se leen los datos de la demanda}
    read(fichero, demanda[i]);

  for i:= 1 to limite_a do
    begin
      for j:= 1 to limite_b do
        read(fichero, tabla[i,j].coste);
      readln(fichero);
    end;
  {comprobamos que ai = bi}
  suma_a:= 0;
  suma_b:= 0;
  for i:= 1 to limite_a do
    suma_a:= suma_a + oferta[i];
  for j:= 1 to limite_b do
    suma_b:= suma_b + demanda[j];
  if suma_a <> suma_b then
    begin
      clrscr;
      write('La oferta no es igual a la demanda.');
      readkey;
      LeerFichero:= false;
      exit;
    end;
  LeerFichero:= true;
End;

(***************************************************************************)
Procedure Visualizar(tabla: matriz; limite_a, limite_b: byte; oferta,demanda: vector);
var i,j: byte;

Begin
  clrscr;
  for i:= 1 to limite_a do
    begin
      for j:= 1 to limite_b do
        begin
          write(tabla[i,j].coste:1:1,'|');
          if not(tabla[i,j].basico) then
            write('X    ')
          else
            write(tabla[i,j].coste_min:1:1,'  ');
        end;
      writeln('   ', oferta[i]:1:1);
    end;
  writeln;
  for i:= 1 to limite_b do
    write('  ', demanda[i]:1:1, '    ');
  readkey;
End;

(***************************************************************************)
END.