UNIT Dos_fa;

INTERFACE

Uses Crt, E_S, Simplex;
Procedure Calcular_A(var A: matrices; n_var, n_rest: rango;
                     funcion: vectores; rest: matrices);
Procedure Dos_fases1(tipo_p: tipo_prob; var n_var: rango; n_rest: rango;
                    funcion: vectores; var rest: matrices; recursos: vectores;
                    n_var_a: rango; var_a: vectores; var S, A: matrices;
                    sw: boolean; var sol_opt, v_b: vectores);

IMPLEMENTATION

(***************************************************************************)
Procedure Calcular_A(var A: matrices; n_var, n_rest: rango;
                     funcion: vectores; rest: matrices);
var i, j: rango;

Begin
  A:= rest;
  for i:= 1 to n_var do
    A[n_rest+1,i]:= funcion[i];
  A[n_rest+2, n_var]:= 1;
End;

(***************************************************************************)
Procedure Dos_fases1(tipo_p: tipo_prob; var n_var: rango; n_rest: rango;
                    funcion: vectores; var rest: matrices; recursos: vectores;
                    n_var_a: rango; var_a: vectores; var S, A: matrices;
                    sw: boolean; var sol_opt, v_b: vectores);
var auxM, P: matrices;
    i,j: rango;
    entra, sale: rango;
    cte: vectores;       {columna constante}
    costes, col_piv, aux: vectores;
    dividir: real;
    fact: boolean;

Begin
  {FASE 1}
  {inicializacin de la matriz S de n_rest+2 columnas * n_rest+2 filas}
  if sw then
    begin
      Buscar_Identidad(n_var, n_rest, rest, S, v_b);
      for i:= 1 to n_rest do
        begin
          S[n_rest+1,i]:= -(funcion[round(v_b[i])]);          {-z}
          S[n_rest+2,i]:= 0;
        end;
      for i:= 1 to n_var_a do
        for j:= 1 to n_rest do
          if var_a[i] = v_b[j] then
            S[n_rest+2,j]:= -1                                    {-w};
      S[n_rest+1,n_rest+1]:= 1;
      S[n_rest+2,n_rest+2]:= 1;

      Calcular_A(A, n_var, n_rest, funcion, rest);
    end;
  repeat
    {clculo de la columna constante= S * b , b= vector de recursos}
    for i:= 1 to n_rest+2 do
      cte[i]:= 0;
    for i:= 1 to n_rest+2 do
      for j:= 1 to n_rest+2 do
        cte[i]:= cte[i] + S[i,j] * recursos[j];

    {clculo del vector de costos}
    for i:= 1 to n_rest+2 do
      costes[i]:= 0;
     for i:= 1 to n_rest+2 do
       for j:= 1 to n_rest+2 do
         costes[i]:= costes[i] + S[n_rest+2,j] * A[j,i];

    if Min(costes, v_b, n_rest+2, entra, false) < 0 then
      begin
        {clculo de la columna pivote}
        for i:= 1 to n_rest+2 do
          col_piv[i]:= 0;
        for i:= 1 to n_rest+2 do
          for j:= 1 to n_rest+2 do
            col_piv[i]:= col_piv[i] + S[i,j] * A[j,entra];

        {variable que sale}
        fact:= false;
        for i:= 1 to n_rest do
          if (col_piv[i] > 0) and (cte[i] >= 0) then
            begin
              aux[i]:= cte[i] / col_piv[i];
              fact:= true;
            end
          else
            aux[i]:= maxint;
        if fact then
          begin
        	Min(aux, v_b, n_rest, sale, false);
        	dividir:= col_piv[sale];

        	Visualiza(S, cte, col_piv, v_b, n_rest+2, false);
        	writeln('Entra X',entra);
        	writeln('Sale X',v_b[sale]:1:0);
        	readkey;

        	{clculo de Pi}
        	for i:= 1 to n_rest+2 do
          	  for j:= 1 to n_rest+2 do
                if i = j then
              	  P[i,j]:= 1
            	else
              	  P[i,j]:= 0;
        	i:= 1;
        	while (v_b[i] <> v_b[sale]) and (i <= n_rest) do
          	  inc(i);
        	for j:= 1 to n_rest+2 do
              if j = i then
                P[j,i] := P[j,i] / dividir
              else
                P[j,i]:= -(col_piv[j] / dividir);

        	Multiplica(P, S, n_rest+2, n_rest+2, n_rest+2, n_rest+2, auxM);
        	S:= auxM;
        	v_b[sale]:= entra;
          end;
      end;
  until (Min(costes, v_b, n_rest+1, i, false) >= 0) or (not (fact));
  writeln;
  writeln;
  Visualiza(S, cte, col_piv, v_b, n_rest+2, false);
  if fact then
    begin
      writeln('Fase 2');
      readkey;
      Simplex_revisado(tipo_p, n_var - n_var_a, n_rest, funcion, rest,
                       recursos, v_b, S, A, false, sol_opt);
    end
  else
    begin
      write('El problema no es factible.');
      readkey;
    end;
End;

END.
