(**************************************************************************)
(* Esta unit contiene las rutinas para cargar los datos de un problema    *)
(* por pantalla o desde fichero. Tambin contiene las estructuras de datos*)
(* a usar.                                                                *)
(**************************************************************************)

UNIT E_S;

INTERFACE

Uses Crt;

Const MAX = 10;

Type rango = 0..MAX;
     tipo_prob = 1..3;
     tipo_rest = array [rango] of char;
     vectores = array [rango] of real;
     matrices = array [rango,rango] of real;

Var fichero: TEXT;

Function Abrir: boolean;
Procedure Leer_teclado(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                       var tipo_r: tipo_rest; var funcion: vectores;
                       var rest: matrices; var recursos: vectores);
Procedure Leer_fichero(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                       var tipo_r: tipo_rest; var funcion: vectores;
                       var rest: matrices; var recursos: vectores);
Procedure Mostrar(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                  var tipo_r: tipo_rest; var funcion: vectores;
                  var rest: matrices; var recursos: vectores);
Procedure Modificar(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                    var tipo_r: tipo_rest; var funcion: vectores;
                    var rest: matrices; var recursos: vectores);

Procedure C_tipo_p(var tipo_p: tipo_prob);
Procedure C_n_var(var n_var: rango);
Procedure C_n_rest(var n_rest: rango);
Procedure C_tipo_r(var tipo_r: tipo_rest; n_rest: rango);
Procedure C_funcion(var funcion: vectores; n_var: rango);
Procedure C_rest(var rest: matrices; n_var, n_rest: rango);
Procedure C_recursos(var recursos: vectores; n_rest: rango);

IMPLEMENTATION

(**************************************************************************)
Function Abrir: boolean;
var entrada: string;

Begin
  clrscr;
  write('Introduce el nombre del fichero: ');
  readln(entrada);
  assign(fichero, entrada);
  {$I-}
  reset(fichero);
  {$I+}
  if ioresult <> 0 then
    begin
      clrscr;
      write('ERROR, el fichero ',entrada,' no ha podido abrirse correctamente.');
      Abrir:= false;
    end
  else
    Abrir:= true;
End;

(**************************************************************************)
Procedure C_tipo_p(var tipo_p: tipo_prob);

Begin
  writeln('TIPO DE PROBLEMA');
  writeln;
  write('Introduce el tipo de problema (1 = mximo, 2 = mnimo): ');
  readln(tipo_p);
End;

(**************************************************************************)
Procedure C_n_var(var n_var: rango);

Begin
  writeln('NUMERO DE VARIABLES DE DECISION');
  writeln;
  write('Introduce el nmero de variables: ');
  readln(n_var);
End;

(**************************************************************************)
Procedure C_n_rest(var n_rest: rango);

Begin
  writeln('NUMERO DE RESTRICCIONES');
  writeln;
  write('Introduce el nmero de restricciones: ');
  readln(n_rest);
End;

(**************************************************************************)
Procedure C_tipo_r(var tipo_r: tipo_rest; n_rest: rango);
var i: rango;

Begin
  writeln('TIPO DE RESTRICCIONES');
  writeln;
  for i:= 1 to n_rest do
    begin
      write('Introduce el tipo de restriccin de la ',i,' (L , E =, G ): ');
      readln(tipo_r[i]);
    end;
End;

(**************************************************************************)
Procedure C_funcion(var funcion: vectores; n_var: rango);
var i: rango;

Begin
  writeln('COEFICIENTES DE LA FUNCION OBJETIVO');
  writeln;
  for i:= 1 to n_var do
    begin
      write('Introduce el coeficiente ',i,' de la funcin objetivo: ');
      readln(funcion[i]);
    end;
End;

(**************************************************************************)
Procedure C_rest(var rest: matrices; n_var, n_rest: rango);
var i,j: rango;

Begin
  writeln('COEFICIENTES DE LAS RESTRICCIONES');
  writeln;
  for i:= 1 to n_rest do
    for j:= 1 to n_var do
      begin
        write('Introduce el coeficiente ',j,' de la restriccin ',i,': ');
        readln(rest[i,j]);
      end;
End;

(**************************************************************************)
Procedure C_recursos(var recursos: vectores; n_rest: rango);
var i: rango;

Begin
  writeln('COEFICIENTES DEL VECTOR DE RECURSOS');
  writeln;
  for i:= 1 to n_rest do
    begin
      write('Introduce el valor del recurso ',i,': ');
      readln(recursos[i]);
    end;
End;

(**************************************************************************)
Procedure Leer_teclado(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                       var tipo_r: tipo_rest; var funcion: vectores;
                       var rest: matrices; var recursos: vectores);
var i,j: rango;

Begin
  clrscr;
  C_tipo_p(tipo_p);
  writeln;
  C_n_var(n_var);
  writeln;
  C_n_rest(n_rest);
  writeln;
  C_tipo_r(tipo_r, n_rest);
  writeln;
  C_funcion(funcion, n_var);
  writeln;
  C_rest(rest, n_var, n_rest);
  writeln;
  C_recursos(recursos, n_rest);
End;

(**************************************************************************)
Procedure Leer_fichero(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                       var tipo_r: tipo_rest; var funcion: vectores;
                       var rest: matrices; var recursos: vectores);
var i, j: rango;
    ch: char;

Begin
  if Abrir then
    begin
      readln(fichero, tipo_p);
      readln(fichero, n_var);
      readln(fichero, n_rest);
      for i := 1 to n_rest do
        begin
          read(fichero, tipo_r[i]);
          read(fichero,ch);
        end;
      for i := 1 to n_var do
        read(fichero, funcion[i]);
      for i := 1 to n_rest do
        begin
          for j := 1 to n_var do
            read(fichero, rest[i, j]);
        end;
      for i := 1 to n_rest do
        read(fichero, recursos[i]);
    end;
  close(fichero);
End;

(**************************************************************************)
Procedure Mostrar(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                       var tipo_r: tipo_rest; var funcion: vectores;
                       var rest: matrices; var recursos: vectores);
var i,j: rango;
    ch: char;
    primera: boolean;

Begin
  clrscr;
  if tipo_p = 1 then
    write('mx ')
  else
    if tipo_p = 2 then
      write('mn ')
    else
      write('- mn ');
  primera:= true;
  for i := 1 to n_var do
    if funcion[i] <> 0 then
      if funcion[i] > 0 then
        if primera then                         { mostrar el signo +}
          begin
            write(funcion[i]:1:1,'X',i,' ');
            primera:= false;
          end
        else
          write('+ ',funcion[i]:1:1,'X',i,' ')
      else
        begin
          write(funcion[i]:1:1,'X',i,' ');
          primera:= false;
        end;
  writeln;
  writeln;
  writeln('s. a ');
  for i := 1 to n_rest do
    begin
      write('      ');
      primera:= true;
      for j := 1 to n_var do
        if rest[i,j] <> 0 then
          if rest[i,j] > 0 then
            if primera then
              begin
                write(rest[i,j]:1:1,'X',j,' ');
                primera:= false;
              end
            else
              write('+ ',rest[i,j]:1:1,'X',j,' ')
          else
            begin
              write(rest[i,j]:1:1,'X',j,' ');
              primera:= false;
            end;
       case upcase(tipo_r[i]) of
         'G': write(' ');
         'L': write(' ');
         'E': write('= ');
       end;
       writeln(recursos[i]:1:1);
    end;
  writeln;
  writeln('      Xi  0');
  writeln;
  writeln;
  write('Desea modificar algn dato?(S/N)');
  ch:= readkey;
  if upcase(ch) = 'S' then
    Modificar(tipo_p, n_var, n_rest, tipo_r, funcion, rest,
              recursos);
End;

(**************************************************************************)
Procedure Modificar(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                    var tipo_r: tipo_rest; var funcion: vectores;
                    var rest: matrices; var recursos: vectores);
var i,j: rango;
    ch: char;

Begin
  clrscr;
  writeln('Modificar:');
  writeln('a) Tipo de problema.');
  writeln('b) Nmero de variables de decisin.');
  writeln('c) Nmero de restricciones.');
  writeln('d) Tipo de restricciones.');
  writeln('e) Coeficientes de la funcin objetivo.');
  writeln('f) Coeficientes de las restricciones.');
  writeln('g) Vector de recursos.');
  writeln('h) Todo.');
  writeln;
  write('Opcin: ');
  ch:= readkey;
  case upcase(ch) of
    'A': begin
           clrscr;
           C_tipo_p(tipo_p);
         end;
    'B': begin
           clrscr;
           C_n_var(n_var);
           C_funcion(funcion, n_var);
           C_rest(rest, n_var, n_rest);
         end;
    'C': begin
           clrscr;
           C_n_rest(n_rest);
           C_rest(rest, n_var, n_rest);
         end;
    'D': begin
           clrscr;
           C_tipo_r(tipo_r, n_rest);
         end;
    'E': begin
           clrscr;
           C_funcion(funcion, n_var);
         end;
    'F': begin
           clrscr;
           C_rest(rest, n_var, n_rest);
         end;
    'G': begin
           clrscr;
           C_recursos(recursos, n_rest);
         end;
    'H': Leer_teclado(tipo_p, n_var, n_rest, tipo_r, funcion, rest,
                      recursos);
  end;
  Mostrar(tipo_p, n_var, n_rest, tipo_r, funcion, rest,
          recursos);
End;

END.