UNIT Menup;

INTERFACE

Uses Crt;

Const n= 10;

Type WinCord = Record
       Xa : Byte;
       Xb : Byte;
       Ya : Byte;
       Yb : Byte;
     end;

     MenuList = Record
       MenuLink  : Integer;
       MenuName  : String;
       Question  : String;
       OpenState : String;
       NumItems  : Integer;
       Items     : Array [1..n] of String;
       ItemCode  : Array [1..n] of Char;
     end;

Var Win: WinCord;
    List: MenuList;
    Xdc,Ydc: Integer;
    Code: Char;

Procedure Border(X, Y : Integer; BackGround : Integer; Color : Integer);
Procedure MenuScr(X, Y : Integer; BackGround : Integer; Color : Integer);
Procedure Println(PStr : String);
Procedure Print(PStr : String);
Function  SrchErr(Cher : Char; List : MenuList) : Boolean;
Procedure ShowError;
Procedure Menu(X, Y :Integer; BackGround : Integer; Color : Integer;
               List : MenuList);
Procedure Command(X, Y :Integer; BackGround : Integer; Color : Integer;
                  List : MenuList);
Procedure InitMenu(Var List : MenuList);
Procedure Normal;


IMPLEMENTATION

(**************************************************************************)
Procedure Border(X,Y : Integer; BackGround : Integer; Color : Integer);
Var Xdc, Ydc : Integer;

Begin
  For Xdc := 2 to (X - 2) do
  begin
    GotoXY(Xdc + 1, 1);
    Write(chr(205));
    GotoXY(Xdc + 1, Y);
    Write(chr(205));
  end;
  For Ydc := 2 to (Y - 3) do
  begin
    GotoXY(1, Ydc + 1);
    Write(chr(186));
    GotoXY(X, Ydc + 1);
    Write(chr(186));
  end;
  GotoXY(2, 1);
  Write(chr(201));
  GotoXY(1, 2);
  Write(chr(201));
  GotoXY(2, 2);
  Write(chr(188));
  GotoXY(X - 1, 1);
  Write(chr(187));
  GotoXY(X, 2);
  Write(chr(187));
  GotoXY(X - 1, 2);
  Write(chr(200));
  GotoXY(1, Y - 1);
  Write(chr(200));
  GotoXY(2, Y);
  Write(chr(200));
  GotoXY(2, Y - 1);
  Write(chr(187));
  GotoXY(X, Y - 1);
  Write(chr(188));
  GotoXY(X - 1, Y);
  Write(chr(188));
  GotoXY(X - 1, Y - 1);
  Write(chr(201)); {201}
End;

Procedure MenuScr(X,Y : Integer; BackGround : Integer; Color : Integer);
Begin
  Window(1, 1, 80, 25);
  TextBackground(Black);
  ClrScr;
  Win.Xa := 40 - Round(X / 2);
  Win.Xb := 40 + Round(X / 2);
  Win.Ya := 12 - Round(Y / 2);
  Win.Yb := 12 + Round(Y / 2);
  X := X + 1;
  Y := Y + 1;
  Window(Win.Xa, Win.Ya, Win.Xb, WIn.Yb);
  TextBackground(BackGround);
  TextColor(Color);
  ClrScr;
  Border(X, Y+1, BackGround, Color);
  GotoXY(3,3);
End;

(**************************************************************************)
Procedure Println(PStr : String);
Var Xdc : Integer;

Begin
  If Length(PStr) > (Win.Xb - Win.Xa - 4) then
  begin
    Writeln('Menu too small...');
    Halt
  end;
  Write(Pstr);
  Xdc := WhereY;
  GotoXY(3, Xdc + 1);
End;

(**************************************************************************)
Procedure Print(PStr : String);
Var Xdc : Integer;

Begin
  If Length(PStr) > (Win.Xb - Win.Xa - 4) then
  begin
    Writeln('Menu too small...');
    Halt
  end;
  Write(Pstr);
End;

(**************************************************************************)
Function SrchErr(Cher : Char; List : MenuList) : Boolean;
Begin
  SrchErr := True;
  For Xdc := 1 to List.NumItems do
    If Cher = List.ItemCode[Xdc] Then
      SrchErr := False;
End;

(**************************************************************************)
Procedure ShowError;
Var Me   : Char;
    T, H : Integer;

Begin
  MenuScr(42, 8, Red, Yellow);
  Println('An Error has been detected.');
  Println('Please be careful in your');
  Println('Value Entering...');
  Print('  [Press Any Key to Continue]');
  Me := ReadKey;
  TextBackground(Black);
  ClrScr;
End;

(**************************************************************************)
Procedure Menu(X, Y : Integer; BackGround : Integer; Color : Integer;
               List : MenuList);
Var PrnStr : String;
    Cord   : Char;

Begin
  MenuScr(X, Y, Background, Color);
  Xdc := Round(X / 2) - round(Length(List.MenuName) / 2);
  GotoXY(Xdc, 2);
  Println(List.MenuName);
  GotoXY(3, 4);
  Println(List.OpenState);
  For Xdc := 1 to List.NumItems do
  begin
    PrnStr := Concat('   ', List.ItemCode[Xdc], ' :  ', List.Items[Xdc]);
    Println(PrnStr);
  end;
  GotoXY(WhereX, WhereY + 1);
  Print(List.Question);
End;

(**************************************************************************)
Procedure Command(X, Y : Integer; BackGround : Integer; Color : Integer;
                  List : MenuList);
Var PrnStr : String;
    Cord   : Char;

Begin
  MenuScr(X, Y, Background, Color);
  Xdc := Round(X / 2) - round(Length(List.MenuName) / 2);
  GotoXY(Xdc, 2);
  Println(List.MenuName);
  GotoXY(3, 3);
  Print(List.Question);
End;

(**************************************************************************)
Procedure InitMenu(Var List : MenuList);
Begin
  TextBackGround(Black);
  Window(1, 1, 80, 25);
  ClrScr;
  List.MenuName  := '';
  List.OpenState := '';
  List.NumItems  := 0;
  For Xdc := 1 to 15 do
    List.Items[Xdc] := '';
  For Xdc := 1 to 15 do
    List.Itemcode[Xdc] := ' ';
  List.Question := '';
End;

(**************************************************************************)
Procedure Normal;
Begin
  Window(1,1,80,25);
  TextBackGround(Black);
End;

END.
