UNIT Param;

INTERFACE

Uses Crt, E_S, Simplex, Sim_dual, Dos_fa;

Procedure Parametrico(tipo_p: tipo_prob; n_var, n_var_i, n_rest: rango; tipo_r: tipo_rest;
                      funcion: vectores; rest: matrices; recursos: vectores;
                      var_a: vectores; n_var_a: rango; var v_p: vectores;
                      v_b, v_b_i: vectores; S, A: matrices; tamano: rango);
Procedure Adicion_c(tipo_p: tipo_prob; n_var, n_rest: rango; tipo_r: tipo_rest;
                    funcion: vectores; rest: matrices; recursos: vectores;
                    var_a: vectores; n_var_a: rango; var v_p: vectores;
                    v_b, v_b_i: vectores; S, A: matrices; tamano: rango);
Procedure Adicion_r(tipo_p: tipo_prob; n_var, n_rest: rango; tipo_r: tipo_rest;
                    funcion: vectores; rest: matrices; recursos: vectores;
                    var_a: vectores; n_var_a: rango; var v_p: vectores;
                    v_b: vectores; S, A: matrices);

IMPLEMENTATION
(**************************************************************************)
Procedure Parametrico(tipo_p: tipo_prob; n_var, n_var_i, n_rest: rango; tipo_r: tipo_rest;
                      funcion: vectores; rest: matrices; recursos: vectores;
                      var_a: vectores; n_var_a: rango; var v_p: vectores;
                      v_b, v_b_i: vectores; S, A: matrices; tamano: rango);
var ch: char;

Begin
  clrscr;
  writeln('a) Parmetros en los costes.');
  writeln('b) Parmetros en los recursos.');
  write('Opcin: ');
  readln(ch);
  case ch of
    'a': Adicion_c(tipo_p, n_var_i, n_rest, tipo_r, funcion, rest, recursos,
                   var_a, n_var_a, v_p, v_b, v_b_i, S, A, tamano);
    'b': Adicion_r(tipo_p, n_var, n_rest, tipo_r, funcion, rest, recursos,
                   var_a, n_var_a, v_p, v_b, S, A);
  end;
End;

(**************************************************************************)
Procedure Adicion_c(tipo_p: tipo_prob; n_var, n_rest: rango; tipo_r: tipo_rest;
                    funcion: vectores; rest: matrices; recursos: vectores;
                    var_a: vectores; n_var_a: rango; var v_p: vectores;
                    v_b, v_b_i: vectores; S, A:matrices; tamano: rango);
var i,j: rango;
    auxM: matrices;
    costes, auxV: vectores;
    C: vectores;                   {C*}
    superior, inferior: real;      {extremos del intervalo}

Begin
  clrscr;
  for i:= 0 to MAX do
    begin
      costes[i]:= 0;
      C[i]:= 0;
      auxV[i]:= 0;
    end;
  for i:= 1 to n_rest do
    costes[round(v_b_i[i])]:= S[tamano,i];
  writeln;
  writeln('Introduce los coeficientes de los prametros en la funcin objetivo.');
  for i:= 1 to n_var do
    begin
      write('',i,': ');        { = 225}
      readln(v_p[i]);
    end;
  Multiplica(S, A, n_rest, n_rest, n_rest, n_var, auxM);
  for i:= 1 to n_var do
    for j:= 1 to n_rest do
      C[i]:= C[i] + v_p[round(v_b[j])] * auxM[j,i];
  for i:= 1 to n_var do
    C[i]:= v_p[i] - C[i];

  for i:= 1 to n_var do
    if C[i] > 0 then
      auxV[i]:= -costes[i] / C[i]
    else
      auxV[i]:= -M;
  inferior:= Maxi(auxV,n_var, i, false);

  for i:= 1 to MAX do
    auxV[i]:= 0;

  for i:= 1 to n_var do
    if C[i] < 0 then
      auxV[i]:= -costes[i] / C[i]
    else
      auxV[i]:= M;
  superior:= Min(auxV, v_b, n_var, i, false);
  writeln;
  if inferior > superior then
    writeln('La base B no tiene asociado ningn intervalo caracterstico, es una base no fatible.')
  else
    begin
      writeln('Los valores de  tal que la funcin objetivo sigue siendo ptima son: ');
      write('  [',inferior:2:2,',',superior:2:2,']');
    end;
  readkey;
End;

(**************************************************************************)
Procedure Adicion_r(tipo_p: tipo_prob; n_var, n_rest: rango; tipo_r: tipo_rest;
                    funcion: vectores; rest: matrices; recursos: vectores;
                    var_a: vectores; n_var_a: rango; var v_p: vectores;
                    v_b: vectores; S, A:matrices);
var i, j: rango;
    b_, auxV: vectores;
    inferior, superior: real;

Begin
  clrscr;
  writeln('Introduce los coeficientes de los prametros en los recursos.');
  for i:= 1 to n_rest do
    begin
      write('',i,': ');
      readln(v_p[i]);
      b_[i]:= 0;
      auxV[i]:= 0;
    end;
  for i:= 1 to n_rest do
    for j:= 1 to n_rest do
      b_[i]:= b_[i] +  v_p[j] * S[j,i];

  for i:= 1 to n_rest do
    if b_[i] > 0 then
      auxV[i]:= -recursos[i] / b_[i]
    else
      auxV[i]:= -M;
  inferior:= Maxi(auxV, n_rest, i, false);

  for i:= 1 to MAX do
    auxV[i]:= 0;

  for i:= 1 to n_rest do
    if b_[i] < 0 then
      auxV[i]:= -recursos[i] / b_[i]
    else
      auxV[i]:= M;
  superior:= Min(auxV, v_b, n_rest, i, false);
  writeln;
  if inferior > superior then
    begin
      writeln('La base B no tiene asociado ningn intervalo caracterstico, ');
      writeln('es una base no fatible.');
    end
  else
    begin
      writeln('Los valores de  tal que la funcin objetivo sigue siendo ptima son: ');
      write('  [',inferior:2:2,',',superior:2:2,']');
    end;
  readkey;
End;

(**************************************************************************)
END.