Program Prog_mat;

Uses Crt, Menup, E_S, Simplex, Dos_fa, Sim_dual, Sensi, Param, Trans, Control;

Var m: MenuList;
    tipo_p, tipo_p_i: tipo_prob;          {tipo de problema}
    n_var, n_var_i: rango;               {n de varibles de decisin}
    n_rest, n_rest_i: rango;              {n de restricciones}
    tipo_r, tipo_r_i: tipo_rest;          {tipo de restriccin de cada restriccin}
    funcion, funcion_i: vectores;          {coeficientes de la funcin objetivo}
    rest, rest_i: matrices;             {coeficientes de las restricciones}
    recursos, recursos_i: vectores;         {vector de recursos}
    S: matrices;                {matriz para el simplex revisado}
    A, S_: matrices;
    v_b, v_b_i: vectores;              {variables bsicas}
    n_var_a: rango;             {n de variables artificiales}
    var_a: vectores;            {variables artificiales}
    problema: boolean;          {indica si hay algn problema cargado}
    sol_opt: vectores;          {solucin ptima}
    v_p: vectores;              {vector de parmetros}

(***************************************************************************)
Procedure Iniciar(var m: MenuList);

Begin
  InitMenu(m);
  with m do
    begin
      MenuLink:= 1;
      MenuName:= 'PROGRAMACION LINEAL';
      Question:= 'Opcin: ';
      OpenState:= '';
      NumItems:= 9;
      items[1]:= 'Salir.';
      itemcode[1]:= '0';
      items[2]:= 'Introducir datos por fichero.';
      itemcode[2]:= '1';
      items[3]:= 'Introducir datos por teclado.';
      itemcode[3]:= '2';
      items[4]:= 'Pasar a forma estndard.';
      itemcode[4]:= '3';
      items[5]:= 'Mostrar / Modificar el problema.';
      itemcode[5]:= '4';
      items[6]:= 'Mtodo del SIMPLEX revisado.';
      itemcode[6]:= '5';
      items[7]:= 'Mtodo DOS FASES.';
      itemcode[7]:= '6';
      items[8]:= 'Mtodo SIMPLEX DUAL.';
      itemcode[8]:= '7';
      items[9]:= 'Transporte.';
      itemcode[9]:= '8';

    end;
End;

(***************************************************************************)
Procedure Ejecutar(var m: MenuList);
var ch,ch1: char;
    d,n,i: integer;
    tamano: rango;

Begin
  repeat
    Menu(47,15,1,15,m);         {anchura, altura}
    ch:= readkey;
    Normal;
    case ch of
      '1': begin
             Leer_fichero(tipo_p_i, n_var_i, n_rest_i, tipo_r_i, funcion_i,
                          rest_i, recursos_i);
             Mostrar(tipo_p_i, n_var_i, n_rest_i, tipo_r_i, funcion_i, rest_i,
                          recursos_i);
             tipo_p:= tipo_p_i;
             n_var:= n_var_i;
             n_rest:= n_rest_i;
             tipo_r:= tipo_r_i;
             funcion:= funcion_i;
             rest:= rest_i;
             recursos:= recursos_i;
             problema:= true;
           end;
      '2': begin
             Leer_teclado(tipo_p_i, n_var_i, n_rest_i, tipo_r_i, funcion_i,
                          rest_i, recursos_i);
             Mostrar(tipo_p_i, n_var_i, n_rest_i, tipo_r_i, funcion_i, rest_i,
                     recursos_i);
             tipo_p:= tipo_p_i;
             n_var:= n_var_i;
             n_rest:= n_rest_i;
             tipo_r:= tipo_r_i;
             funcion:= funcion_i;
             rest:= rest_i;
             recursos:= recursos_i;
             problema:= true;
           end;
      '3': if problema then
             begin
               Estandar_dual(tipo_p, n_var, n_rest, tipo_r, funcion, rest,
                             recursos, n_var_a, var_a);
               Buscar_Identidad(n_var, n_rest, rest, S_, v_b_i);
             end;
      '4': if problema then
             begin
               Mostrar(tipo_p, n_var, n_rest, tipo_r, funcion, rest, recursos);
               tipo_p:= tipo_p_i;
               n_var:= n_var_i;
               n_rest:= n_rest_i;
               tipo_r:= tipo_r_i;
               funcion:= funcion_i;
               rest:= rest_i;
               recursos:= recursos_i;
             end;
      '5': if problema then
             begin
               Simplex_revisado(tipo_p, n_var, n_rest, funcion, rest, recursos,
                              v_b, S, A, true, sol_opt);
               repeat
               until Sensibilidad(tipo_p_i, n_var_i, n_rest_i, tipo_r_i, funcion_i,
                            rest_i, recursos_i, tipo_p, n_var, n_rest,
                            tipo_r, funcion, rest, recursos, S, A, v_b, v_b_i,
                            sol_opt)= 'N';
               writeln;
               write('Desea aadir parmetros?(s/n)?');
               ch1:= readkey;
               if upcase(ch1) = 'S' then
                 Parametrico(tipo_p, n_var, n_var_i, n_rest, tipo_r, funcion, rest, recursos_i,
                         var_a, n_var_a, v_p, v_b, v_b_i, S, A, n_rest_i+1);
             end;
      '6': if problema then
             begin
               Dos_fases1(tipo_p, n_var, n_rest, funcion, rest, recursos, n_var_a,
                      var_a, S, A, true, sol_opt, v_b);
               repeat
               until Sensibilidad(tipo_p_i, n_var_i, n_rest_i, tipo_r_i, funcion_i,
                            rest_i, recursos_i, tipo_p, n_var, n_rest,
                            tipo_r, funcion, rest, recursos, S, A, v_b, v_b_i, sol_opt) = 'N';
               writeln;
               write('Desea aadir parmetros?(s/n)?');
               ch1:= readkey;
               if upcase(ch1) = 'S' then
                 Parametrico(tipo_p, n_var, n_var_i, n_rest, tipo_r, funcion, rest, recursos_i,
                         var_a, n_var_a, v_p, v_b, v_b_i, S, A, n_rest+2);
             end;
      '7': if problema then
             begin
               Decidir(tipo_p, n_var, n_rest, funcion, rest, recursos, v_b, v_b_i,
                       S, A, sol_opt, tamano, true);
               repeat
               until Sensibilidad(tipo_p_i, n_var_i, n_rest_i, tipo_r_i, funcion_i,
                            rest_i, recursos_i, tipo_p, n_var, n_rest,
                            tipo_r, funcion, rest, recursos, S, A, v_b, v_b_i, sol_opt) = 'N';
               writeln;
               write('Desea aadir parmetros?(s/n)?');
               ch1:= readkey;
               if upcase(ch1) = 'S' then
                 Parametrico(tipo_p, n_var, n_var_i, n_rest, tipo_r, funcion, rest, recursos_i,
                         var_a, n_var_a, v_p, v_b, v_b_i, S, A, tamano);
             end;
      '8': begin
             if LeerFichero(limite_a, limite_b, oferta, demanda, tabla) then
               begin
                 Visualizar(tabla, limite_a, limite_b, oferta, demanda);
                 NW(tabla, limite_a, limite_b, oferta, demanda);
                 Algoritmo(tabla, limite_a, limite_b, oferta, demanda);
               end;
           end;

      end;
  until (ch= '0');
End;

(***************************************************************************)
BEGIN
  Iniciar(m);
  Ejecutar(m);
END.