UNIT Sensi;

INTERFACE

Uses Crt, E_S, Simplex, Sim_dual, Dos_fa;

Function Sensibilidad(tipo_p: tipo_prob; n_var, n_rest: rango;
                       tipo_r: tipo_rest; funcion: vectores;
                       rest: matrices; recursos: vectores;
                        {parametros una vez resuelto el problema}
                       tipo_p_n: tipo_prob; n_var_n, n_rest_n: rango;
                       tipo_r_n: tipo_rest; funcion_n: vectores;
                       rest_n: matrices; recursos_n: vectores;
                       S, A: matrices; v_b, v_b_i, sol_opt: vectores): char;
Function Most(var tipo_p: tipo_prob; var n_var, n_rest: rango;
              var tipo_r: tipo_rest; var funcion: vectores;
              var rest: matrices; var recursos: vectores): char;
Function Modif(var tipo_p: tipo_prob; var n_var, n_rest: rango;
               var tipo_r: tipo_rest; var funcion: vectores;
               var rest: matrices; var recursos: vectores): char;
Function Comprobar(n_var, n_rest: rango; rest: matrices;
                   recursos, v_b, sol_opt: vectores; tipo_r: tipo_rest): boolean;

var col: rango;
IMPLEMENTATION

Function Sensibilidad(tipo_p: tipo_prob; n_var, n_rest: rango;
                       tipo_r: tipo_rest; funcion: vectores;
                       rest: matrices; recursos: vectores;
                       tipo_p_n: tipo_prob; n_var_n, n_rest_n: rango;
                       tipo_r_n: tipo_rest; funcion_n: vectores;
                       rest_n: matrices; recursos_n: vectores;
                       S, A: matrices; v_b, v_b_i, sol_opt: vectores): char;
var opcion: char;
    basico: boolean;
    i,j: rango;
    cambiado, v_basicas: array[rango] of boolean;  {variables que han cambiado}
    pcc: rango;                         {posicin del coste cambiado}
    vcc: real;                          {valor del coste cambiado}
    C: vectores;
    C1: matrices;
    var_a: vectores;                    {var artificiales}
    w: vectores;
    S_, A_: matrices;                   {S y A modificadas}
    dual: vectores;                     {ltima restriccin dual}
    sol_dual: vectores;                 {solucin dual}
    suma: real;
    dual_: vectores;

Begin
  opcion:= Most(tipo_p, n_var, n_rest, tipo_r, funcion, rest_n, recursos);
  for i:= 1 to n_var do
    begin
      cambiado[i]:= false;
      if tipo_p = 1 then
        funcion[i]:= -funcion[i];
    end;
  case opcion of
    'A': begin  {cambio en la funcin objetivo}
           Sensibilidad:= 'S';
           basico:= false;
           for i:= 1 to n_var do
             if funcion[i] <> funcion_n[i] then
               begin
                 cambiado[i]:= true;
                 pcc:= i;
               end;
           for i:= 1 to n_var do
             if cambiado[i] then
               for j:= 1 to n_rest_n do
                 if v_b[j]= i then
                   basico:= true;
           writeln;
           if basico then
             begin
               writeln('Cambio en un costo bsico.');
               for i:= 1 to MAX do
                 C[i]:= 0;
               Multiplica(S, A, n_rest_n, n_rest_n, n_rest_n, n_var_n, C1);
               for i:= 1 to n_rest_n do
                 for j:= 1 to n_var_n do
                   C[j]:= C[j] + funcion[round(v_b[i])] * C1[i,j];
               for i:= 1 to n_var_n do
                 C[i]:= funcion[i] - C[i];
               if (Min(C, v_b, n_var_n, i, false) < 0) then
                 begin
                   write('(');
                   for i:= 1 to n_var_n do
                     write(C[i]:1:1,',');
                   gotoXY(whereX-1, whereY);
                   writeln(')');
                   writeln('El nuevo vector de costes  0');
                   readkey;
                   A_:= A;
                   S_:= S;
                   for i:= 1 to n_var_n do
                     C[i]:= 0;
                   for i:= 1 to n_rest do
                     for j:= 1 to n_rest do
                       C[i]:= C[i] + (-funcion[round(v_b[j])]) * S_[j,i];
                   for i:= 1 to n_rest do
                     S_[n_rest+1, i]:= C[i];
                   Simplex_revisado(tipo_p_n, n_var_n, n_rest_n, funcion, rest_n,
                                  recursos_n, v_b, S_, A_, false, sol_opt);
                 end
               else
                 begin
                   write('(');
                   for i:= 1 to n_var_n do
                     write(C[i]:1:1,',');
                   gotoXY(whereX-1, whereY);
                   writeln(')');
                   writeln('El nuevo vector de costes  0');
                   suma:= 0;
                   for i:= 1 to n_rest do
                     suma:= suma + funcion[round(v_b[i])] * sol_opt[i];
                   if tipo_p = 1 then
                     suma:= -suma;
                   writeln('El valor de la funcin objetivo es ahora: ',suma:1:1);
                   readkey;
                 end
             end
           else
             begin
               writeln('Cambio en un costo no bsico.');
               vcc:= funcion[pcc];
               A_:= A;
               S_:= S;
               A_[n_rest+1, pcc]:= funcion[pcc];
               for i:= 0 to MAX do
                 C[i]:= 0;
               for i:= 1 to n_rest do               {producto S * Aj}
                 for j:= 1 to n_var do
                   C[i]:= C[i] + S[i,j] * A_[j, pcc];
               for i:= 1 to n_rest do
                 C[0]:= C[0] + C[i] * funcion[round(v_b[i])];
               vcc:= vcc - C[0];
               writeln('Valor de la nueva componente(',pcc,'): ',vcc:0:1);
               if vcc < 0 then
                 begin
                   writeln('La nueva componente es  0');
                   readkey;
                   for i:= 1 to n_var_n do
                     C[i]:= 0;
                   for i:= 1 to n_rest_n do
                     for j:= 1 to n_rest_n do
                       C[i]:= C[i] + (-funcion[round(v_b[j])]) * S[j,i];
                   for i:= 1 to n_rest do
                     S_[n_rest+1, i]:= C[i];
                   Simplex_revisado(tipo_p_n, n_var_n, n_rest_n, funcion, rest_n,
                                    recursos_n, v_b, S_, A_, false, sol_opt);
                 end
               else
                 begin
                   writeln('La nueva componente es  0');
                   readkey;
                 end;
             end;
         end;
    'B': begin  {cambio en las restricciones}
           Sensibilidad:= 'S';
           basico:= false;
           j:= 1;
           while not(basico) and (j <= n_rest) do
             begin
               if v_b[j]= col then
                 basico:= true;
               inc(j);
             end;
           if basico then        {cambio en una columna bsica}
             begin
               writeln;
               writeln('Cambio en una columna bsica.');
               readkey;
               inc(n_var_n);
               for i:= 1 to n_rest do
                 begin
                   A[i,n_var_n]:= rest[i,col];
                   A[i,col]:= rest_n[i,col];
                 end;
               var_a[1]:= n_var_n;
               v_b[j-1]:= var_a[1];
               funcion_n[n_var_n]:= 1;
               for i:= 1 to n_rest+1 do
                 w[i]:= 0;
               for i:= 1 to n_rest do
                 for j:= 1 to n_rest do
                   if j = col then
                     w[i]:= w[i] -S[j,i];
               {actualizacin de S}
               for i:= 1 to n_rest+1 do
                 begin
                   S[i,n_rest+2]:= 0;
                   S[n_rest+2,i]:= w[i];
                 end;
               S[n_rest+1,n_rest+1]:= 1;
               S[n_rest+2,n_rest+2]:= 1;

               Dos_fases1(tipo_p_n, n_var_n, n_rest_n, funcion_n, rest_n,
                          recursos_n, 1, var_a, S, A, false, sol_opt, v_b);
             end
           else                 {cambio en una columna no bsica}
             begin
               writeln;
               writeln('Cambio en un columna no bsica.');
               vcc:= funcion[col];
               A_:= A;
               for i:= 1 to n_rest do
                 A_[i,col]:= rest_n[i,col];
               for i:= 0 to MAX do
                 C[i]:= 0;
               for i:= 1 to n_rest do               {producto S * Aj}
                 for j:= 1 to n_var do
                   C[i]:= C[i] + S[i,j] * A_[j, col];
               for i:= 1 to n_rest do
                 C[0]:= C[0]+ C[i] * funcion[round(v_b[i])];
               vcc:= vcc - C[0];
               writeln('Valor de la nueva componente(',col,'): ',vcc:0:1);
               if vcc < 0 then
                 begin
                   writeln('La nueva componente es  0');
                   readkey;
                   Simplex_revisado(tipo_p_n, n_var_n, n_rest_n, funcion, rest_n,
                                    recursos_n, v_b, S, A_, false, sol_opt);
                 end
               else
                 begin
                   writeln('La nueva componente es  0');
                   readkey;
                 end;
             end;
         end;
    'C': begin       {cambio en los recursos}
         Sensibilidad:= 'S';
           for i:= 1 to MAX do
             C[i]:= 0;
           for i:= 1 to n_rest do
             for j:= 1 to n_rest do
               C[i]:= C[i] + S[i,j] * recursos[j];
           writeln;
           write('(');
           for i:= 1 to n_rest do
             write(C[i]:1:1,',');
           gotoXY(whereX-1,whereY);
           writeln(')');
           if (Min(C, v_b, n_rest, i, false) >= 0) then
             begin
               writeln('El vector de recursos es  0');
               suma:= 0;
               for i:= 1 to n_rest do
                 suma:= suma + funcion[round(v_b[i])] * C[i];
               if tipo_p = 1 then
                 suma:= -suma;
               writeln('El nuevo valor de la funcin objetivo es: ',suma:1:1);
               readkey;
             end
           else
             begin
               write('El vector de recursos es  0');
               readkey;
{               S_:= S;
               A_:= A;
               for i:= 1 to n_var_n+1 do
                 v_basicas[i]:= false;
               for i:= 1 to n_var_n do
                 for j:= 1 to n_rest do
                   if v_b_i[j] = i then
                     v_basicas[i]:= true;
               inc(n_rest_n);
               inc(n_var_n);
               {aade una restriccin ms, con las variables no bsicas}
{               for i:= 1 to n_var_n do
                 if not(v_basicas[i]) then
                   rest_n[n_rest_n,i]:= 1
                 else
                   rest_n[n_rest_n,i]:= 0;
               recursos[n_rest_n]:= M;
               v_b[n_rest_n]:= n_var_n;
               {inicializacin de A}
{               for i:= 1 to n_var_n do
                 begin
                   A_[n_rest_n+1,i]:= funcion_n[i];
                   A_[n_rest_n,i]:= rest_n[n_rest_n,i];
                 end;
               for i:= 1 to n_rest_n do
                 A_[i,n_var_n+1]:= 0;
               A_[n_rest_n+1,n_var_n+1]:= 1;

               {inicializacin de S}
{               for i:= 1 to n_rest_n do
                 begin
                   S_[n_rest_n+1,i]:= S_[n_rest_n,i];
                   S_[i,n_rest_n]:= 0;
                   S_[n_rest_n,i]:= 0
                 end;
               S_[n_rest_n+1,n_rest_n+1]:= 1;
               S_[n_rest_n,n_rest_n]:= 1;
               S_[n_rest_n+1,n_rest_n]:= 0;}

               Simplex_dual(tipo_p_n, n_var_n, n_rest_n, funcion_n, rest_n,
                            recursos, v_b, S, A, false, sol_opt, false);
{               Decidir(tipo_p_n, n_var_n, n_rest_n, funcion_n, rest_n,
                       recursos, v_b, v_b_i, S_, A_, sol_opt, i, false);}
             end;
         end;
    'D': begin  {adicin de una nueva restriccin}
           Sensibilidad:= 'S';
           if Comprobar(n_var, n_rest, rest_n, recursos, v_b, sol_opt, tipo_r) then
             begin
               writeln;
               write('Esta restriccin no afecta al problema.');
               readkey;
             end
           else
             begin
               writeln;
               write('Esta restriccin afecta al problema.');
               readkey;
               S_:= S;
               A_:= A;
               for i:= 1 to n_rest do
                 C[i]:= 0;
               for i:= 1 to n_rest-1 do
                 for j:= 1 to n_rest-1 do
                   C[i]:= C[i] + (-rest_n[n_rest,round(v_b[j])]) * S_[j,i];
               for i:= 1 to n_rest-1 do
                 S_[n_rest+1,i]:= S_[n_rest,i];
               for i:= 1 to n_rest do
                   S_[i,n_rest+1]:= 0;
               S_[n_rest,n_rest]:= 1;
               S_[n_rest+1,n_rest+1]:= 1;
               for i:= 1 to n_rest-1 do
                 S_[n_rest,i]:= C[i];
               if (tipo_r[n_rest] = 'L') then
                 begin
                   for i:= 1 to n_var_n do
                     begin
                       A_[n_rest+1,i]:= A_[n_rest,i];
                       A_[n_rest,i]:= rest_n[n_rest,i];
                     end;
                   inc(n_var_n);
                   A_[n_rest,n_var_n]:= 1;
                   rest_n[n_rest,n_var_n]:= 1;
                   v_b[n_rest]:= n_var_n;

                   Simplex_revisado(tipo_p_n, n_var_n, n_rest, funcion_n, rest_n,
                                recursos, v_b, S_, A_, false, sol_opt);
                 end
               else
                 if (tipo_r[n_rest] = 'G') then
                   begin
                     for i:= 1 to n_var_n do
                       begin
                         A_[n_rest+1,i]:= A_[n_rest,i];
                         rest_n[n_rest,i]:= -rest_n[n_rest,i];
                         A_[n_rest,i]:= rest_n[n_rest,i];
                       end;
                     recursos[n_rest]:= -recursos[n_rest];
                     A_[n_rest,n_var_n+1]:= 1;
                     rest_n[n_rest,n_var_n+1]:= 1;
                     inc(n_var_n);
                     v_b[n_rest]:= n_var_n;

                     Decidir(tipo_p_n, n_var_n, n_rest, funcion_n, rest_n,
                       recursos, v_b, v_b_i, S_, A_, sol_opt, i, false);
                     dec(n_var_n);
                   end
                 else {la restriccin aadidad es '=' -> dos fases}
                   begin
                     for i:= 1 to n_var_n do
                       begin
                         A_[n_rest+1,i]:= A_[n_rest,i];
                         A_[n_rest,i]:= rest_n[n_rest,i];
                       end;
                     A_[n_rest,n_var_n+1]:= 1;
                     rest_n[n_rest,n_var_n+1]:= 1;
                     var_a[1]:= n_var_n+1;
                     v_b[n_rest]:= var_a[1];
                     for i:= 1 to n_rest do
                       S_[n_rest+2,i]:= -S_[n_rest,i];
                     S_[n_rest+2,n_rest+2]:= 1;
                     inc(n_var_n);
                     Dos_fases1(tipo_p_n, n_var_n, n_rest, funcion_n, rest_n,
                          recursos, 1, var_a, S_, A_, false, sol_opt, v_b);
                     dec(n_var_n);
                   end;
             end;
         end;
    'E': begin  {adicin de una variable}
           Sensibilidad:= 'S';
           {construccin de la solucin dual}
           for i:= 1 to n_rest do
             sol_dual[i]:= S[n_rest+1,i];
           {construccin de la restriccin dual}
           for i:= 1 to n_rest do
             dual[i]:= rest_n[i,n_var];

           {comprobar que la restriccin se verifica}
           suma:= 0;
           for i:= 1 to n_rest do
             suma:= suma + dual[i] * sol_dual[i];
           if ((suma >= funcion[n_var]) and (tipo_p = 2)) or
              ((suma >= -funcion[n_var]) and (tipo_p = 1))then
             begin
               writeln;
               writeln('La nueva variable no afecta a la tabla ptima.');
               readkey;
             end
           else
             begin
               writeln;
               writeln('La nueva variable afecta a la tabla ptima.');
               readkey;
               {construccin de la nueva tabla}

               {se calcula la columna correspondiente a la nueva variable}
               for i:= 1 to n_rest do
                 dual_[i]:= 0;
               for i:= 1 to n_rest do
                 for j:= 1 to n_rest do
                   dual_[i]:= dual_[i] + S[i,j] * dual[i];
               suma:= 0;
               for i:= 1 to n_rest do
                 suma:= suma + funcion[round(v_b[i])] * dual_[i];
               suma:= funcion[n_var] - suma;
               {se modifica la matriz A}
               for i:= 1 to n_rest+1 do
                 for j:= n_var to n_var_n+1 do
                   A[i,j+1]:= A[i,j];
               for i:= 1 to n_rest do
                 A[i,n_var]:= rest_n[i,n_var];
               A[n_rest+1,n_var]:= funcion[n_var];

               if suma < 0 then
                 begin
                   funcion_n[n_var]:= funcion[n_var];
                   inc(n_var_n);
                   Simplex_revisado(tipo_p_n, n_var_n, n_rest, funcion_n, rest_n,
                                recursos, v_b, S, A, false, sol_opt);
                 end;
             end;
         end;
    'N': Sensibilidad:= 'N';
  end;
End;

(**************************************************************************)
Function Most(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                       var tipo_r: tipo_rest; var funcion: vectores;
                       var rest: matrices; var recursos: vectores): char;
var i,j: rango;
    ch: char;
    primera: boolean;

Begin
  clrscr;
  if tipo_p = 1 then
    write('mx ')
  else
    if tipo_p = 2 then
      write('mn ')
    else
      write('- mn ');
  primera:= true;
  for i := 1 to n_var do
    if funcion[i] <> 0 then
      if funcion[i] > 0 then
        if primera then                         { mostrar el signo +}
          begin
            write(funcion[i]:1:1,'X',i,' ');
            primera:= false;
          end
        else
          write('+ ',funcion[i]:1:1,'X',i,' ')
      else
        begin
          write(funcion[i]:1:1,'X',i,' ');
          primera:= false;
        end;
  writeln;
  writeln;
  writeln('s. a ');
  for i := 1 to n_rest do
    begin
      write('      ');
      primera:= true;
      for j := 1 to n_var do
        if rest[i,j] <> 0 then
          if rest[i,j] > 0 then
            if primera then
              begin
                write(rest[i,j]:1:1,'X',j,' ');
                primera:= false;
              end
            else
              write('+ ',rest[i,j]:1:1,'X',j,' ')
          else
            begin
              write(rest[i,j]:1:1,'X',j,' ');
              primera:= false;
            end;
       case upcase(tipo_r[i]) of
         'G': write(' ');
         'L': write(' ');
         'E': write('= ');
       end;
       writeln(recursos[i]:1:1);
    end;
  writeln;
  writeln('      Xi  0');
  writeln;
  writeln;
  write('Desea modificar algn dato?(S/N)');
  ch:= readkey;
  if upcase(ch) = 'S' then
    Most:= Modif(tipo_p, n_var, n_rest, tipo_r, funcion, rest,
              recursos)
  else Most:= 'N';
End;

(**************************************************************************)
Function Modif(var tipo_p: tipo_prob; var n_var, n_rest: rango;
                    var tipo_r: tipo_rest; var funcion: vectores;
                    var rest: matrices; var recursos: vectores): char;
var i: rango;
    ch: char;

Begin
  clrscr;
  writeln('Modificar:');
  writeln('a) Coeficientes de la funcin objetivo.');
  writeln('b) Coeficientes de las restricciones.');
  writeln('c) Vector de recursos.');
  writeln('d) Adicin de una nueva restriccin.');
  writeln('e) Adicin de una variable.');
  writeln;
  write('Opcin: ');
  ch:= readkey;
  case upcase(ch) of
    'A': begin
           clrscr;
           C_funcion(funcion, n_var);
           Modif:= 'A';
         end;
    'B': begin
           clrscr;
           write('Introduce la columna a cambiar: ');
           readln(col);
           for i:= 1 to n_rest do
             begin
               write('X',i,col,'= ');
               readln(rest[i,col]);
             end;
           Modif:= 'B';
         end;
    'C': begin
           clrscr;
           C_recursos(recursos, n_rest);
           Modif:= 'C';
         end;
    'D': begin
           clrscr;
           inc(n_rest);
           for i:= 1 to n_var do
             begin
               write('X',n_rest,i,'= ');
               readln(rest[n_rest,i]);
             end;
           write('Tipo de restriccin (L , E =, G ): ');
           readln(tipo_r[n_rest]);
           write('Introduce el valor del recurso: ');
           readln(recursos[n_rest]);
           Modif:= 'D';
         end;
    'E': begin
           clrscr;
           inc(n_var);
           write('Coeficiente de la nueva variable para la funcin objetivo: ');
           readln(funcion[n_var]);
           for i:= 1 to n_rest do
             begin
               write('Coeficiente para la ',i,' restriccin: ');
               readln(rest[i,n_var]);
             end;
           Modif:= 'E';
         end;
  end;
  Most(tipo_p, n_var, n_rest, tipo_r, funcion, rest,
          recursos);
End;

(**************************************************************************)
Function Comprobar(n_var, n_rest: rango; rest: matrices;
                   recursos, v_b, sol_opt: vectores; tipo_r: tipo_rest): boolean;
var i: rango;
    resultado: real;

Begin
  resultado:= 0;
  for i:= 1 to n_rest-1 do
    resultado:= resultado + rest[n_rest,round(v_b[i])] * sol_opt[round(v_b[i])];
  if ((tipo_r[n_rest] = 'L') and (resultado <= recursos[n_rest])) or
     ((tipo_r[n_rest] = 'G') and (resultado >= recursos[n_rest])) or
     ((tipo_r[n_rest] = 'E') and (resultado = recursos[n_rest])) then
    Comprobar:= true
  else
    Comprobar:= false;
End;

(**************************************************************************)
END.