UNIT Simplex;

INTERFACE

Uses Crt, E_S;


Procedure Lexicografico(V, v_b: vectores; a, b: rango; var pos: rango);
Procedure Multiplica(A,B: matrices; n1, m1, n2, m2: rango; var C: matrices);
Function Min(V, v_b: vectores; k: rango; var pos: rango; sale: boolean): real;
Function Comprobar_columna(n_rest, j: rango; rest: matrices;var k: rango): boolean;
Procedure Buscar_Identidad(n_var, n_rest: rango; rest: matrices;
                          var S: matrices; var v_b: vectores);
Procedure Estandar(var tipo_p: tipo_prob; var n_var: rango; n_rest: rango;
                   var tipo_r: tipo_rest; var funcion: vectores;
                   var rest: matrices; var recursos: vectores;
                   var n_var_a: rango; var var_a: vectores);
Procedure Tabla_inicial(n_var, n_rest: rango; funcion: vectores; rest: matrices;
                        recursos: vectores; var A: matrices; v_b: vectores);
Procedure Hacer_tabla(n: rango);
Procedure Visualiza(S: matrices; cte, col_piv, v_b: vectores; n: rango;
                    simplex: boolean);
Procedure Simplex_revisado(tipo_p: tipo_prob; n_var, n_rest: rango; funcion: vectores;
                           rest: matrices; recursos: vectores; var v_b: vectores;
                           var S, A: matrices; simplex: boolean; var sol_opt: vectores);

IMPLEMENTATION

(*************************************************************************)
Procedure Lexicografico(V, v_b: vectores; a, b: rango; var pos: rango);
var i: rango;

Begin
  if v_b[a] > v_b[b] then
    pos:= a
  else
    pos:= b;
End;

(*************************************************************************)
{La matriz A es de tamao n1xm1 y la B n2xm2}
Procedure Multiplica(A, B: matrices; n1, m1, n2, m2: rango; var C: matrices);
var i, j, k: rango;

Begin
  for i:= 1 to n1 do
    for j:= 1 to m2 do
      C[i,j]:= 0;
  for i:= 1 to n1 do
    for k:= 1 to m2 do
      for j:= 1 to m1 do
        C[i,k]:= C[i,k] + A[i,j] * B[j,k];
End;

(*************************************************************************)
Function Min(V, v_b: vectores; k: rango; var pos: rango; sale: boolean): real;
var i, aux: rango;
    m: real;

Begin
  m:= maxint;
  for i:= 1 to k do
    if V[i] < m then
      begin
        m:= V[i];
        pos:= i;
      end
    else
      if V[i] = m then
        if sale then
          Lexicografico(V, v_b, pos, i, pos);
  Min:= m;
End;

(*************************************************************************)
{Devuelve si la columna j pertenece a la matriz identidad y en k la posicin
del uno en la columna}
Function Comprobar_columna(n_rest, j: rango; rest: matrices; var k: rango): boolean;
var i: rango;
    uno: boolean;
    comprobar: array[rango] of boolean;

Begin
  comprobar[0]:= true;
  i:= 1;
  uno:= false;
  while (i <= n_rest) and (comprobar[i-1]) do
    begin
      if uno then
        if rest[i,j] = 0 then
          comprobar[i]:= true
        else
          comprobar[i]:= false
      else
        if rest[i,j] = 1 then
          begin
            uno:= true;
            k:= i;
            comprobar[i]:= true;
          end
        else
          if rest[i,j] = 0 then
            comprobar[i]:= true
          else
            comprobar[i]:= false;
      inc(i);
    end;
  Comprobar_columna:= comprobar[i-1] and uno;
End;

(*************************************************************************)
Procedure Buscar_Identidad(n_var, n_rest: rango; rest: matrices;
                          var S: matrices; var v_b: vectores);
var i, j, k: rango;

Begin
  for i:= 1 to n_var do
    if Comprobar_columna(n_rest, i, rest, k) then
      begin
        v_b[k]:= i;
        for j:= 1 to n_rest do
          S[j,k]:= rest[j,i];
      end;
End;

(*************************************************************************)
Procedure Estandar(var tipo_p: tipo_prob; var n_var: rango; n_rest: rango;
                   var tipo_r: tipo_rest; var funcion: vectores;
                   var rest: matrices; var recursos: vectores;
                   var n_var_a: rango; var var_a: vectores);
var i, j, k: rango;
    pertenece: boolean;
    necesaria: array[rango] of boolean;

Begin
  n_var_a:= 0;
  { ningn recurso sea negativo}
  for i:= 1 to n_rest do
    if recursos[i] < 0 then
      begin
        recursos[i]:= -recursos[i];
        case upcase(tipo_r[i]) of
          'L': tipo_r[i] := 'G';
          'G': tipo_r[i] := 'L';
        end;
        for j:= 1 to n_var do
          rest[i,j] := -rest[i,j];
      end;

  { el problema sea mnimo}
  if tipo_p = 1 then
    begin
      tipo_p := 3;
      for i:= 1 to n_var do
        funcion[i] := - funcion[i];
    end;

  {el tipo de las restricciones sea = aadiendo variables de holg.}
  for i:= 1 to n_rest do
    case upcase(tipo_r[i]) of
      'L': begin
             inc(n_var);
             rest[i,n_var] := 1;
             tipo_r[i] := 'E';
           end;
      'G': begin
             inc(n_var);
             rest[i,n_var] := -1;
             tipo_r[i] := 'E';
           end;
    end;
  for i:= 1 to n_rest do
    case upcase(tipo_r[i]) of
      'E': begin
             j:= 1;
             necesaria[0]:= true;
             while (j <= n_var) and (necesaria[j-1]) do
               begin
                 if rest[i,j] = 1 then
                   necesaria[j]:= not(Comprobar_columna(n_rest, j, rest, k))
                 else
                   necesaria[j]:= true;
                 inc(j);
               end;
             if necesaria[j-1] then
               begin
                 inc(n_var);
                 inc(n_var_a);
                 var_a[n_var_a]:= n_var;
                 rest[i,n_var]:= 1;
               end;
           end;
    end;
  Mostrar(tipo_p, n_var, n_rest, tipo_r,
          funcion, rest, recursos);
End;

(*************************************************************************)
Procedure Tabla_inicial(n_var, n_rest: rango; funcion: vectores; rest: matrices;
                        recursos: vectores; var A: matrices; v_b: vectores);
var i, j: rango;
    x: byte;

Begin
  clrscr;
  write('vb');
  for i:= 1 to n_var do
    write('     ');
  write(' -z   cte ');
  x:= WhereX;
  writeln;
  write('');
  for i:= 3 to x-15 do
    write('');
  write('Ĵ');
  writeln;
  for i:= 1 to n_rest+1 do
    begin
      write('  ');
      for j:= 1 to n_var do
        write('     ');
      write('          ');
      writeln;
    end;
  write('');
  for i:= 3 to x-15 do
    write('');
  write('');

  for i:= 1 to n_var do
    begin
      gotoxy(5 + 5 * (i-1),1);
      write('X',i);
    end;
  for i:= 1 to n_rest do
    begin
      gotoxy(1,i+2);
      write('X', v_b[i]:1:0);
      for j:= 1 to n_var do
        begin
          gotoxy(4+(j-1)*5,i+2); write(rest[i,j]:1:1);
          A[i,j]:= rest[i,j];
          gotoxy(6+n_var*5,i+2); write(rest[i,n_var+1]:1:1);
          gotoxy(12+n_var*5,i+2); write(recursos[i]:1:1);
        end;
    end;
  gotoxy(1,n_rest+3);
  write('-z');
  for i:= 1 to n_var do
    begin
      gotoxy(4+(i-1)*5,n_rest+3);
      write(funcion[i]:1:1);
    end;
  gotoxy(6+n_var*5,n_rest+3);
  write('1.0');
  gotoxy(7+(n_var+1)*5,n_rest+3);
  write('0.0');
  readkey;
  gotoxy(1,n_rest+4);
End;

(***************************************************************************)
Procedure Hacer_tabla(n: rango);  {191, 192, 193, 194, 195, 196, 197}
var i, j: rango;                     {217, 218, ,179, 180}
    x: byte;

Begin
  clrscr;
  write('vb');
  for i:= 1 to n do
    write('     ');
  write(' cte col. pivote');
  x:= WhereX;
  writeln;
  write('');
  for i:= 3 to x-21 do
    write('');
  write('Ĵ');
  writeln;
  for i:= 1 to n do
    begin
      write('  ');
      for j:= 1 to n do
        write('     ');
      write('                ');
      writeln;
    end;
  write('');
  for i:= 3 to x-21 do
    write('');
  write('');
End;

(***************************************************************************)
Procedure Visualiza(S: matrices; cte, col_piv, v_b: vectores; n: rango;
                    simplex: boolean);
var i, j: rango;

Begin
  Hacer_tabla(n);
  gotoxy(4 + n * 2,1); write('S');
  for i:= 1 to n do
    begin
      gotoxy(1,i+2); write('X', v_b[i]:1:0);
      for j:= 1 to n do
        begin
          gotoxy(j*5,i+2); write(S[i,j]:1:1);
          gotoxy(6+n*5,i+2); write(cte[i]:1:1);
          gotoxy(15+n*5,i+2); write(col_piv[i]:1:1);
        end;
    end;
  if simplex then
    begin
      gotoxy(1,n+2);
      write('-z');
    end
  else
    begin
      gotoxy(1,n+1); write('-z');
      gotoxy(1,n+2); write('-w');
    end;
  gotoxy(1,n+4);
End;

(*************************************************************************)
Procedure Simplex_revisado(tipo_p: tipo_prob; n_var, n_rest: rango; funcion: vectores;
                           rest: matrices; recursos: vectores; var v_b: vectores;
                           var S, A: matrices; simplex: boolean; var sol_opt: vectores);
var cte, col_piv, costes, aux: vectores;
    i, j, entra, sale: rango;
    P, auxM: matrices;
    dividir: real;
    factible: boolean;

Begin
  factible:= true;
  if simplex then
    begin
      Buscar_Identidad(n_var, n_rest, rest, S, v_b);
      Tabla_inicial(n_var, n_rest, funcion, rest, recursos, A, v_b);
      {inicializacin de A}
      for i:= 1 to n_var do
        A[n_rest+1,i]:= funcion[i];
      {inicializacin de S}
      for i:= 1 to n_rest do
        begin
          S[i,n_rest+1]:= 0;
          S[n_rest+1,i]:= -funcion[round(v_b[i])];
        end;
      S[n_rest+1,n_rest+1]:= 1;
    end;
  repeat
    {columna cte}
    for i:= 1 to n_rest+1 do
      cte[i]:= 0;
    for i:= 1 to n_rest+1 do
      for j:= 1 to n_rest+1 do
        cte[i]:= cte[i] + S[i,j] * recursos[j];

    {clculo de costes}
    for i:= 1 to n_var do
      costes[i]:= 0;
    for i:= 1 to n_var do
      for j:= 1 to n_rest+1 do
        costes[i]:= costes[i] + S[n_rest+1,j] * A[j,i];
    if (Min(costes, v_b, n_var, entra, false) < 0) then
      begin
        {columna pivote}
        for i:= 1 to n_rest+1 do
          col_piv[i]:= 0;
        for i:= 1 to n_rest+1 do
          for j:= 1 to n_rest+1 do
            col_piv[i]:= col_piv[i] + S[i,j] * A[j,entra];
        Visualiza(S, cte, col_piv, v_b, n_rest+1, true);
        readkey;
        factible:= false;
        for i:= 1 to n_rest do
          if (col_piv[i] > 0) and (cte[i] >= 0) then
            begin
              aux[i]:= cte[i] / col_piv[i];
              factible:= true;
            end
          else
            aux[i]:= maxint;
        if factible then
          begin
            Min(aux, v_b, n_rest, sale, true);
            dividir:= col_piv[sale];
            writeln;
            writeln('Entra X',entra);
            writeln('Sale X',v_b[sale]:1:0);
            readkey;

            {clculo de Pi}
            for i:= 1 to n_rest+1 do
              for j:= 1 to n_rest+1 do
                if i = j then
                  P[i,j]:= 1
                else
                  P[i,j]:= 0;
            i:= 1;
            while (v_b[i] <> v_b[sale]) and (i <= n_rest) do
              inc(i);
            for j:= 1 to n_rest+1 do
              if j = i then
                P[j,i] := P[j,i] / dividir
              else
                P[j,i]:= -(col_piv[j] / dividir);

            Multiplica(P, S, n_rest+1, n_rest+1, n_rest+1, n_rest+1, auxM);
            for i:= 1 to n_rest+1 do
              for j:= 1 to n_rest+1 do
                S[i,j]:= auxM[i,j];
            v_b[sale]:= entra;
            end;
          end;

  until (Min(costes, v_b, n_var, i, false) >= 0) or (not(factible));
  Visualiza(S, cte, col_piv, v_b, n_rest+1, true);
  writeln;
  writeln;
  for i:= 1 to n_var do
    sol_opt[i]:= 0;
  if factible then
    begin
      if tipo_p = 3 then
        write('Valor de la funcin objetivo: ',cte[n_rest+1]:1:1)
      else
        write('Valor de la funcin objetivo: ',-cte[n_rest+1]:1:1);
      for i:= 1 to n_rest do
        sol_opt[round(v_b[i])]:= cte[i];
    end
  else
    write('El problema no es factible.');
  readkey;
End;


(*************************************************************************)
END.