UNIT Sim_dual;

INTERFACE

Uses Crt, E_S, Simplex;

Const M = maxint;

Function Maxi(V: vectores; k: rango; var pos: rango; lexico: boolean): real;
Procedure Estandar_dual(var tipo_p: tipo_prob; var n_var: rango; n_rest: rango;
                        var tipo_r: tipo_rest; var funcion: vectores;
                        var rest: matrices; var recursos: vectores;
                        var n_var_a: rango; var var_a: vectores);
Procedure Decidir(tipo_p: tipo_prob; n_var, n_rest: rango; funcion: vectores;
                  rest: matrices; recursos: vectores; var v_b, v_b_i: vectores;
                  var S, A: matrices; var sol_opt: vectores; var tamano: rango;
                  sw: boolean);
Procedure Simplex_dual(tipo_p: tipo_prob; n_var, n_rest: rango; funcion: vectores;
                       rest: matrices; recursos: vectores; var v_b: vectores;
                       var S, A: matrices; base_factible: boolean; var sol_opt: vectores;
                       sw: boolean);

IMPLEMENTATION

(*************************************************************************)
Function Maxi(V: vectores; k: rango; var pos: rango; lexico: boolean): real;
var i: rango;
    m: real;

Begin
  m:= V[1];
  pos:= 1;
  for i:= 2 to k do
    if (V[i] > m) or ((lexico) and (V[i] = m)) then
      begin
        m:= V[i];
        pos:= i;
      end;
  Maxi:= m;
End;

(*************************************************************************)
Procedure Estandar_dual(var tipo_p: tipo_prob; var n_var: rango; n_rest: rango;
                   var tipo_r: tipo_rest; var funcion: vectores;
                   var rest: matrices; var recursos: vectores;
                   var n_var_a: rango; var var_a: vectores);
var i, j, k: rango;
    pertenece: boolean;
    necesaria: array[rango] of boolean;
    costos: boolean;        {TRUE si son positivos}
    recur: boolean;      {TRUE si son positivos}
    artificiales: boolean;  {TRUE si hay variables artificiales}
Begin
  n_var_a:= 0;
  artificiales:= false;

  { el problema sea mnimo}
  if tipo_p = 1 then
    begin
      tipo_p := 3;
      for i:= 1 to n_var do
        funcion[i] := - funcion[i];
    end;

  {el tipo de las restricciones sea = aadiendo variables de holg.}
  for i:= 1 to n_rest do
    case upcase(tipo_r[i]) of
      'L': begin
             inc(n_var);
             rest[i,n_var] := 1;
             tipo_r[i] := 'E';
           end;
      'G': begin
             inc(n_var);
             rest[i,n_var] := -1;
             tipo_r[i] := 'E';
             for j:= 1 to n_var do
               rest[i,j]:= -rest[i,j];
             recursos[i]:= -recursos[i];
           end;
      'E': begin
             j:= 1;
             necesaria[0]:= true;
             while (j <= n_var) and (necesaria[j-1]) do
               begin
                 if rest[i,j] = 1 then
                   necesaria[j]:= not(Comprobar_columna(n_rest, j, rest, k))
                 else
                   necesaria[j]:= true;
                 inc(j);
               end;
             if (necesaria[j-1] and (j <= n_var)) then
               begin
                 for j:=1 to n_var do
                   rest[i,j]:= -rest[i,j];
                 recursos[i]:= -recursos[i];
               end;
           end;
    end;
  for i:= 1 to n_rest do
    case upcase(tipo_r[i]) of
      'E': begin
             j:= 1;
             necesaria[0]:= true;
             while (j <= n_var) and (necesaria[j-1]) do
               begin
                 if rest[i,j] = 1 then
                   necesaria[j]:= not(Comprobar_columna(n_rest, j, rest, k))
                 else
                   necesaria[j]:= true;
                 inc(j);
               end;
             if necesaria[j-1] then
               begin
                 inc(n_var);
                 inc(n_var_a);
                 var_a[n_var_a]:= n_var;
                 rest[i,n_var]:= 1;
                 artificiales:= true;
               end;
           end;
    end;
  Mostrar(tipo_p, n_var, n_rest, tipo_r,
          funcion, rest, recursos);

  writeln;
  recur:= true;
  costos:= true;
  if artificiales then
    write('Recomendado usar DOS FASES.')
  else
    begin
      for i:= 1 to n_var do
        if funcion[i] < 0 then
          costos:= false;
      for i:= 1 to n_rest do
        if recursos[i] < 0 then
          recur:= false;
      if (costos and recur) or (not(costos) and recur) then
        write('Recomendado usar SIMPLEX REVISADO.');  {base factible primal}
      if costos and not(recur) then
        write('Recomendado usar SIMPLEX DUAL (base factible dual)');
      if not(costos) and not(recur) then
        write('Recomendado usar SIMPLEX DUAL (base factible no dual)');
    end;
  readkey;
End;

(*************************************************************************)
Procedure Decidir(tipo_p: tipo_prob; n_var, n_rest: rango; funcion: vectores;
                  rest: matrices; recursos: vectores; var v_b, v_b_i: vectores;
                  var S, A: matrices; var sol_opt: vectores; var tamano: rango;
                  sw: boolean);
var cte, col_piv, costes: vectores;
    i, j, entra, sale, aux: rango;
    P, auxM: matrices;
    dividir: real;
    v_basicas: array[rango] of boolean;

Begin
  if (Min(funcion, v_b, n_var, i, false) < 0) then
    begin                      {base no factible dual}
      if sw then
       begin
         tamano:= n_rest+2;
         Buscar_Identidad(n_var, n_rest, rest, S, v_b);
         for i:= 1 to n_var+1 do
           v_basicas[i]:= false;
         for i:= 1 to n_var do
           for j:= 1 to n_rest do
             if v_b_i[j] = i then
               v_basicas[i]:= true;
         inc(n_rest);
         inc(n_var);
         {aade una restriccin ms, con las variables no bsicas}
         for i:= 1 to n_var do
           if not(v_basicas[i]) then
             rest[n_rest,i]:= 1
           else
             rest[n_rest,i]:= 0;
         recursos[n_rest]:= M;
         Buscar_Identidad(n_var, n_rest, rest, S, v_b);
         Tabla_inicial(n_var, n_rest, funcion, rest, recursos, A, v_b);
         {inicializacin de A}
         for i:= 1 to n_var do
           A[n_rest+1,i]:= funcion[i];
         for i:= 1 to n_rest do
           A[i,n_var+1]:= 0;
         A[n_rest+1,n_var+1]:= 1;

         {inicializacin de S}
         for i:= 1 to n_rest do
           begin
             S[i,n_rest+1]:= 0;
             S[n_rest+1,i]:= -funcion[round(v_b[i])];
           end;
         S[n_rest+1,n_rest+1]:= 1;
       end;

      {primera iteracin que elimina de la base X0}
      {columna cte}
      for i:= 1 to n_rest+1 do
        cte[i]:= 0;
      for i:= 1 to n_rest+1 do
        for j:= 1 to n_rest+1 do
          cte[i]:= cte[i] + S[i,j] * recursos[j];

      {clculo de costes}
      for i:= 1 to n_var+1 do
        costes[i]:= 0;
      for i:= 1 to n_var+1 do
        for j:= 1 to n_rest+1 do
          costes[i]:= costes[i] + S[n_rest+1,j] * A[j,i];

      if (Min(costes, v_b, n_var, entra, false) < 0) then
        begin

          {columna pivote}
          for i:= 1 to n_rest+1 do
            col_piv[i]:= 0;
          for i:= 1 to n_rest+1 do
            for j:= 1 to n_rest+1 do
              col_piv[i]:= col_piv[i] + S[i,j] * A[j,entra];
          Visualiza(S, cte, col_piv, v_b, n_rest+1, true);
          readkey;
          sale:= n_rest;
          dividir:= col_piv[sale];
          writeln;
          writeln('Entra X',entra);
          writeln('Sale X',v_b[sale]:1:0);
          readkey;

          {clculo de Pi}
          for i:= 1 to n_rest+1 do
            for j:= 1 to n_rest+1 do
              if i = j then
                P[i,j]:= 1
              else
                P[i,j]:= 0;
          i:= 1;
          while (v_b[i] <> v_b[sale]) and (i <= n_rest) do
            inc(i);
          for j:= 1 to n_rest+1 do
            if j = i then
              P[j,i] := P[j,i] / dividir
            else
              P[j,i]:= -(col_piv[j] / dividir);

          Multiplica(P, S, n_rest+1, n_rest+1, n_rest+1, n_rest+1, auxM);
          S:= auxM;
          v_b[sale]:= entra;
        end;

      Simplex_dual(tipo_p, n_var, n_rest, funcion, rest, recursos, v_b, S, A,
                   false, sol_opt, sw);
    end
  else
    begin
      Simplex_dual(tipo_p, n_var, n_rest, funcion, rest, recursos, v_b, S, A,
                   true, sol_opt, sw);
      tamano:= n_rest+1;
    end;

End;

(*************************************************************************)
Procedure Simplex_dual(tipo_p: tipo_prob; n_var, n_rest: rango; funcion: vectores;
                       rest: matrices; recursos: vectores; var v_b: vectores;
                       var S, A: matrices; base_factible: boolean; var sol_opt: vectores;
                       sw: boolean);
var cte, col_piv, costes, aux: vectores;
    i, j, entra, sale: rango;
    P, auxM: matrices;
    dividir: real;
    X0in: boolean;              {X0 est al final en la base}

Begin
  if base_factible and sw then
    begin
      Buscar_Identidad(n_var, n_rest, rest, S, v_b);
      Tabla_inicial(n_var, n_rest, funcion, rest, recursos, A, v_b);
      {inicializacin de A}
      for i:= 1 to n_var do
        A[n_rest+1,i]:= funcion[i];
      for i:= 1 to n_rest do
        A[i,n_var+1]:= 0;
      A[n_rest+1,n_var+1]:= 1;
      {inicializacin de S}
      for i:= 1 to n_rest do
        begin
          S[i,n_rest+1]:= 0;
          S[n_rest+1,i]:= -funcion[round(v_b[i])];
        end;
      S[n_rest+1,n_rest+1]:= 1;
    end;
  repeat
    {columna cte}
    for i:= 1 to n_rest+1 do
      cte[i]:= 0;
    for i:= 1 to n_rest+1 do
      for j:= 1 to n_rest+1 do
        cte[i]:= cte[i] + S[i,j] * recursos[j];

    {clculo de costes}
    for i:= 1 to n_var do
      costes[i]:= 0;
    for i:= 1 to n_var do
      for j:= 1 to n_rest+1 do
        costes[i]:= costes[i] + S[n_rest+1,j] * A[j,i];

    if (Min(costes, v_b, n_var, entra, false) >= 0) and
       (Min(cte, v_b, n_rest, i, false) < 0) then
      begin
        Min(cte, v_b, n_rest, entra, false);
        for i:= 1 to n_var do
          aux[i]:= 0;
        for i:= 1 to n_var do
          for j:= 1 to n_rest+1 do
            aux[i]:= aux[i] + S[entra,j] * A[j,i];

        for i:= 1 to n_var do
          if ((aux[i] < 0) and (costes[i] <> 0)) then
            aux[i]:= costes[i] / aux[i]
          else
            aux[i]:= -maxint;
        Maxi(aux, n_var, entra,true);

        {columna pivote}
        for i:= 1 to n_rest+1 do
          col_piv[i]:= 0;
        for i:= 1 to n_rest+1 do
          for j:= 1 to n_rest+1 do
            col_piv[i]:= col_piv[i] + S[i,j] * A[j,entra];
        Visualiza(S, cte, col_piv, v_b, n_rest+1, true);
        readkey;
        Min(col_piv, v_b, n_rest, sale, true);
        dividir:= col_piv[sale];
        writeln;
        writeln('Entra X',entra);
        writeln('Sale X',v_b[sale]:1:0);
        readkey;

        {clculo de Pi}
        for i:= 1 to n_rest+1 do
          for j:= 1 to n_rest+1 do
            if i = j then
              P[i,j]:= 1
            else
              P[i,j]:= 0;
        i:= 1;
        while (v_b[i] <> v_b[sale]) and (i <= n_rest) do
          inc(i);
        for j:= 1 to n_rest+1 do
          if j = i then
            P[j,i] := P[j,i] / dividir
          else
            P[j,i]:= -(col_piv[j] / dividir);

        Multiplica(P, S, n_rest+1, n_rest+1, n_rest+1, n_rest+1, auxM);
        S:= auxM;
        v_b[sale]:= entra;
      end;
  until (Min(cte, v_b, n_rest, i, false) >= 0) or
        (Min(costes, v_b, n_var, entra, false) < 0);

  Visualiza(S, cte, col_piv, v_b, n_rest+1, true);
  writeln;
  writeln;
  for i:= 1 to n_var do
    sol_opt[i]:= 0;
  X0in:= false;
  for i:= 1 to n_rest do
    if n_var= v_b[i] then
      X0in:= true;
  if X0in then
    begin
      if tipo_p = 3 then
        write('Valor de la funcin objetivo: ',cte[n_rest+1]:1:1)
      else
        write('Valor de la funcin objetivo: ',-cte[n_rest+1]:1:1);
      for i:= 1 to n_rest do
        sol_opt[round(v_b[i])]:= cte[i];
    end
  else
    if (cte[n_rest+1] > M /10) then
      write('Problema factible no acotado.')
    else
      begin
        if tipo_p = 3 then
          write('Valor de la funcin objetivo: ',cte[n_rest+1]:1:1)
        else
          write('Valor de la funcin objetivo: ',-cte[n_rest+1]:1:1);
        for i:= 1 to n_rest do
          sol_opt[round(v_b[i])]:= cte[i];
      end;
  readkey;
End;


END.