UNIT Trans;

INTERFACE
Uses Crt, control;
                                              {fila,columna}
Const Direccion : array[1..4,1..2] of integer = ((-1,0),
                                                 (0,1),
                                                 (1,0),
                                                 (0,-1));

Type caminos = array[1..20,1..20] of boolean;
     posicion = record
       i,j: byte;
     end;
     numer = array[byte] of posicion;

Var limite_a: byte;         {limite del vector a}
    limite_b: byte;         {lmite del vector b}
    oferta: vector;               {vector de oferta}
    demanda: vector;               {vector de demanda}
    tabla: matriz;           {tabla del problema}
    numeracion: numer;
    numeracion_opt: numer;
    optimo: byte;
    num_vert: byte;

Procedure NW(var tabla: matriz; limite_a, limite_b: byte; var oferta, demanda: vector);
Function Maximo(tabla: matriz; limite_a, limite_b: byte;
                var pos_i, pos_j: byte): real;
Procedure Camimin(var camino: caminos; tabla: matriz; limite_a, limite_b,
                  pos_i, pos_j: byte);
Function Eliminar(var camino: caminos; limite_a, limite_b: byte): boolean;
Procedure Renumerar(camino: caminos; var nuevo: byte);
Function Minimo(nuevo: byte; var pos_i, pos_j: byte): real;
Procedure Algoritmo(var tabla: matriz; limite_a, limite_b: byte; oferta,demanda: vector);

IMPLEMENTATION
(***************************************************************************)
Procedure NW(var tabla: matriz; limite_a, limite_b: byte; var oferta, demanda: vector);
var i,j: byte;
    min: real;                  {mnimo entre ai y bj}
    valor: real;                {valor de la funcin objetivo}
    empate: boolean;

Begin
  valor:= 0;
  for i:= 1 to limite_a do
    for j:= 1 to limite_b do
      if not(tabla[i,j].basico) then
      begin
        empate:= false;
        {se elige el mnimo entre ai y bj}
        if oferta[i] > demanda[j] then
          min:= demanda[j];
        if demanda[j] > oferta[i] then
          min:= oferta[i];
        if oferta[i] = demanda[j] then
          begin
            min:= oferta[i];
            empate:= true;
          end;

        if min > 0 then
          begin
            oferta[i]:= oferta[i] - min;
            demanda[j]:= demanda[j] - min;
            tabla[i,j].coste_min:= min;
            tabla[i,j].basico:= true;
          end
        else
          tabla[i,j].basico:= false;

{caso de empate se pone la casilla siguiente (en la fila o la columna como }
{bsica ya que debemos tener m+n-1 variables bsicas}
        if (empate) and (oferta[i] = 0) and (i < limite_a) then
          tabla[i+1,j].basico:= true
        else
          if (empate) and (demanda[j] = 0) and (j < limite_b) then
            tabla[i,j+1].basico:= true;
        valor:= valor + tabla[i,j].coste * tabla[i,j].coste_min;
      end;
  Visualizar(tabla, limite_a, limite_b, oferta, demanda);
  writeln;
  write('Valor de la funcin objetivo: ', valor:1:1);
  readkey;
End;

(***************************************************************************)
Function Maximo(tabla: matriz; limite_a, limite_b: byte;
                var pos_i, pos_j: byte): real;
var i, j: byte;
    maxi: real;

Begin
  maxi:= 0;
  for i:= 1 to limite_a do
    for j:= 1 to limite_b do
      if not(tabla[i,j].basico) and (tabla[i,j].coste_min > maxi) then
        begin
          maxi:= tabla[i,j].coste_min;
          pos_i:= i;
          pos_j:= j;
        end;
  Maximo:= maxi;
End;

(***************************************************************************)
Procedure Camimin(var camino: caminos; tabla: matriz; limite_a, limite_b,
                  pos_i, pos_j: byte);
var i,j,k: byte;
   vert: byte;
   camino_opt: caminos;

  Procedure Back(x,y: byte; d: byte; num_vert_: byte);
  Begin
    if (x > 0) and (x <= limite_a) and (y > 0) and (y <= limite_b) and not(camino[x,y]) then
      begin
        numeracion[num_vert_].i:= x;
        numeracion[num_vert_].j:= y;
        camino[x,y]:= true;
        if num_vert_ <= optimo then
          begin
            if not(tabla[x,y].basico) then
              begin
                Back(x+direccion[d,1],y + direccion[d,2],d,num_vert_+1);
                camino[x,y]:= false;
              end
            else
              if (x = pos_i) and (y = pos_j) and (num_vert_ > 3) then
                begin
                  numeracion_opt:= numeracion;
                  optimo:= num_vert_;
                  camino_opt:= camino;
                end
              else
                if not((x = pos_i) and (y = pos_j)) then
                  begin
                    Back(x+direccion[1,1],y+direccion[1,2],1,num_vert_+1);
                    Back(x+direccion[2,1],y+direccion[2,2],2,num_vert_+1);
                    Back(x+direccion[3,1],y+direccion[3,2],3,num_vert_+1);
                    Back(x+direccion[4,1],y+direccion[4,2],4,num_vert_+1);
                    camino[x,y]:= false;
                  end
                else
                  camino[pos_i,pos_j]:= false;
          end;
      end;
  End;

Begin
  for i:= 1 to limite_a do
    for j:= 1 to limite_b do
      camino[i,j]:= false;

  optimo:= limite_a * limite_b;
  vert:= 1;
  numeracion[vert].i:= pos_i;
  numeracion[vert].j:= pos_j;
  for k:= 1 to 4 do
    begin
      i:= pos_i + direccion[k,1];
      j:= pos_j + direccion[k,2];
      camino[pos_i,pos_j]:= false;
      Back(i, j, k,vert+1);
    end;
  num_vert:= optimo-1;
  numeracion:= numeracion_opt;
  camino:= camino_opt;
End;

(***************************************************************************)
Function Eliminar(var camino: caminos; limite_a, limite_b: byte): boolean;
var i, j: byte;
    num: byte;
    V: array[byte] of byte;   {posiciones en la fila o columna de las que
                                forman parte del camino}
    eli: boolean;

Begin
  eli:= false;
  {se comprueba por filas}
  for i:= 1 to limite_a do
    begin
      num:= 0;
      for j:= 1 to limite_b do
        if camino[i,j] then
          if not (tabla[i,j].basico) then
            begin
              camino[i,j]:= false;
              eli:= true;
            end
          else
            begin
              inc(num);
              V[num]:= j;
            end;
      if num > 2 then
        begin
          eli:= true;
          for j:= 2 to num-1 do {las que sobran son las del medio}
            camino[i,V[j]]:= false;
        end;
    end;

  {se comprueba por columnas}
  for j:= 1 to limite_b do
    begin
      num:= 0;
      for i:= 1 to limite_a do
        if camino[i,j] then
          if not (tabla[i,j].basico) then
            begin
              camino[i,j]:= false;
              eli:= true;
            end
          else
            begin
              inc(num);
              V[num]:= i;
            end;
      if num > 2 then
        begin
          for i:= 2 to num-1 do
            camino[V[i],j]:= false;
          eli:= true;
        end;
    end;
  Eliminar:= eli;
End;

(***************************************************************************)
Procedure Renumerar(camino: caminos; var nuevo: byte);
var i,j: byte;
    eli: byte;

Begin
  eli:= 0;
  for i:= 1 to num_vert do
    if not(camino[numeracion[i].i,numeracion[i].j]) and (i <= (num_vert-eli)) then
      begin
        for j:= i to num_vert do
          numeracion[j]:= numeracion[j+1];
        dec(i);
        inc(eli);
      end;
  nuevo:= num_vert - eli;
End;

(***************************************************************************)
Function Minimo(nuevo: byte; var pos_i, pos_j: byte): real;
var i: byte;
    min: real;

Begin
  min:= maxint;
  for i:= 2 to nuevo do
    if not(Odd(i)) then
      if tabla[numeracion[i].i,numeracion[i].j].coste_min < min then
        begin
          min:= tabla[numeracion[i].i,numeracion[i].j].coste_min;
          pos_i:= numeracion[i].i;
          pos_j:= numeracion[i].j;
        end;
  Minimo:= min;
End;

(***************************************************************************)
Procedure Algoritmo(var tabla: matriz; limite_a, limite_b: byte; oferta,demanda: vector);
var U, V: vector;
    U_, V_: array[byte] of boolean; {inidican que valores se conocen}
    iterar: boolean;   {indica que hay que seguir iterando ya que algn
                        coste no bsico es > 0}
    i,j: byte;
    maxi: real;                 {elemento mximo de la tabla}
    pos_i, pos_j: byte;        {posicin en la tabla del elemento mximo}
    camino: caminos;    {indica la casillas que forman parte del camino mnimo}
    min: real;
    nuevo: byte;       {nuevo n de vrtices}
    suma: real;
    cambio: byte;

Begin
  repeat
    iterar:= false;
    {inicializacin de Ui y Vj}
    for i:= 1 to limite_a do
      begin
        U[i]:= 0;
        U_[i]:= false;
      end;
    for j:= 1 to limite_b-1 do
      begin
        V[j]:= 0;
        V_[j]:= false;
      end;
    V[limite_b]:= 0;
    V_[limite_b]:= true;
    {calculamos todos los Ui y Vj}
    repeat
      cambio:= 1;
      for j:= limite_b downto 1 do
        for i:= limite_a downto 1 do
          if tabla[i,j].basico then
            if V_[j] then
              begin
                U[i]:= tabla[i,j].coste - V[j];
                U_[i]:= true;
                inc(cambio);
              end
            else
              if U_[i] then
                begin
                  V[j]:= tabla[i,j].coste - U[i];
                  V_[j]:= true;
                  inc(cambio);
                end;
    until cambio >= limite_a + limite_b;

    {calculamos las variables no bsicas}
    for i:= 1 to limite_a do
      for j:= 1 to limite_b do
        if not(tabla[i,j].basico) then
          begin
            tabla[i,j].coste_min:= U[i] + V[j] - tabla[i,j].coste;
            if tabla[i,j].coste_min > 0 then
              iterar:= true;
          end;

    if iterar then
      begin
        {se calcula la variable que entra}
        maxi:= Maximo(tabla, limite_a, limite_b, pos_i, pos_j);
        tabla[pos_i,pos_j].basico:= true;

        {se calcula el camino mmino}
        Camimin(camino, tabla, limite_a, limite_b, pos_i, pos_j);
        {elimina las casillas que sobran}
        nuevo:= num_vert;
        if Eliminar(camino, limite_a, limite_b) then
          Renumerar(camino, nuevo);

        Visualizar(tabla, limite_a, limite_b, oferta, demanda);
        writeln;
        writeln('Camino mnimo: ');
        write('( ');
        for i:= 1 to limite_a do
          for j:= 1 to limite_b do
            if camino[i,j] then
              write('(',i,',',j,') ');
        writeln(')');
        readkey;

        {calculo la variable que sale}
        min:= Minimo(nuevo, pos_i, pos_j);

        {actualizo las variables bsicas}
        tabla[pos_i,pos_j].basico:= false;
        tabla[numeracion[1].i,numeracion[1].j].coste_min:= min;
        for i:= 2 to nuevo do
          if (tabla[numeracion[i].i,numeracion[i].j].basico) then
            if Odd(i) then   {es impar, se suma}
              tabla[numeracion[i].i,numeracion[i].j].coste_min:= tabla[numeracion[i].i,numeracion[i].j].coste_min + min
            else
              tabla[numeracion[i].i,numeracion[i].j].coste_min:= tabla[numeracion[i].i,numeracion[i].j].coste_min - min
      end;

  until not(iterar);
  suma:= 0;
  for i:= 1 to limite_a do
    for j:= 1 to limite_b do
      if tabla[i,j].basico then
        suma:= suma + tabla[i,j].coste * tabla[i,j].coste_min;
  Visualizar(tabla, limite_a, limite_b, oferta, demanda);
  writeln;
  writeln('Valor de la funcin objetivo: ', suma:1:1);
  readkey;
End;

(***************************************************************************)
END.